const config = require('./config');
const { Wallet } = require("ethers");
const { stringify } = require("csv");
const fs = require('fs/promises');

const logo = () => {
  console.log();
  console.log();
  console.log();
  console.log('/$$$$$$$$ / $$                 /$$    /$$  /$$$$$$  /$$$$$$$$');
  console.log('|__  $$__/| $$                | $$   | $$ /$$__  $$| $$_____/');
  console.log('   | $$   | $$$$$$$   /$$$$$$ | $$   | $$| $$  \\__/| $$');
  console.log('   | $$   | $$__  $$ /$$__  $$|  $$ / $$/|  $$$$$$ | $$$$$');
  console.log('   | $$   | $$  \\ $$| $$$$$$$$ \\  $$ $$/  \\____  $$| $$__/');
  console.log('   | $$   | $$  | $$| $$_____/  \\  $$$/   /$$  \\ $$| $$');
  console.log('   | $$   | $$  | $$|  $$$$$$$   \\  $/   |  $$$$$$/| $$$$$$$$');
  console.log('   |__/   |__/  |__/ \\_______/    \\_/     \\______/ |________/');
  console.log();
  console.log();
  console.log();
}

const init = async () => {
  logo();

  const wallets = [];

  for (let i = 0; i < config.WALLETS_AMOUNT; i++) {
    const wallet = Wallet.createRandom();
    const { address, mnemonic: { phrase }, privateKey } = wallet;

    console.log(`Wallet #${i + 1}`, {
      address, phrase, privateKey,
    });

    wallets.push({
      address, phrase, privateKey
    });
  }

  if (config.OUTPUT_FILE) {
    await fs.writeFile(config.OUTPUT_FILE, '');

    stringify(wallets, {
      header: true
    }).on('readable', async function() {
      let row; while ((row = this.read()) !== null) {
        await fs.appendFile(config.OUTPUT_FILE, row);
      }
    })
  }
}

init();